// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "RxViewX_Sample_MFC.h"
#include "RxViewXDefinitions.h"
#include <atlbase.h>


#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
	ON_WM_SIZE()
	ON_WM_INITMENUPOPUP()
	ON_COMMAND(ID_VIEW_RX_FILE_TABS, OnViewRxFileTabs)
	ON_COMMAND(ID_VIEW_RX_CONTROL_BAR, OnViewRxControlBar)
	ON_COMMAND(ID_VIEW_RX_REDLINE_BAR, OnViewRxRedlineBar)
	ON_COMMAND(ID_VIEW_RX_STATUS_BAR, OnViewRxStatusBar)
	ON_COMMAND(ID_ZOOM_ALL, OnZoomAll)
	ON_COMMAND(ID_ZOOM_HEIGHT, OnZoomHeight)
	ON_COMMAND(ID_ZOOM_WIDTH, OnZoomWidth)
	ON_COMMAND(ID_ZOOM_NONE, OnZoomNone)
	ON_COMMAND(ID_ZOOM_IN, OnZoomIn)
	ON_COMMAND(ID_ZOOM_OUT, OnZoomOut)
	ON_COMMAND(ID_ZOOM_WINDOW, OnZoomWindow)
	ON_COMMAND(ID_PAN, OnPan)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_CLOSE, OnFileClose)
	ON_COMMAND(ID_WINDOW_CLOSE, OnWindowClose)
	ON_COMMAND(ID_WINDOW_CLOSE_ALL, OnWindowCloseAll)
	ON_COMMAND(ID_FILE1, OnFile1)
	ON_COMMAND(ID_FILE2, OnFile2)
	ON_COMMAND(ID_FILE3, OnFile3)
	ON_COMMAND(ID_FILE4, OnFile4)
	ON_COMMAND(ID_FILE5, OnFile5)
	ON_COMMAND(ID_FILE6, OnFile6)
	ON_COMMAND(ID_FILE7, OnFile7)
	ON_COMMAND(ID_FILE8, OnFile8)
	ON_COMMAND(ID_WINDOW1, OnWindow1)
	ON_COMMAND(ID_WINDOW2, OnWindow2)
	ON_COMMAND(ID_WINDOW3, OnWindow3)
	ON_COMMAND(ID_WINDOW4, OnWindow4)
	ON_COMMAND(ID_WINDOW5, OnWindow5)
	ON_COMMAND(ID_WINDOW6, OnWindow6)
	ON_COMMAND(ID_WINDOW7, OnWindow7)
	ON_COMMAND(ID_WINDOW8, OnWindow8)
	ON_COMMAND(ID_WINDOW9, OnWindow9)
	ON_COMMAND(ID_VIEW_RX_LAY_ON_TABS, OnViewRxLayOnTabs)
	ON_COMMAND(ID_VIEW_BEV, OnViewBev)
	ON_COMMAND(ID_OPT_FILTER, OnOptFilter)
	ON_COMMAND(ID_OPT_PREF, OnOptPref)
	ON_COMMAND(ID_OPT_VECTOR, OnOptVector)
	ON_COMMAND(ID_RED_PREF, OnRedPref)
	ON_COMMAND(ID_RED_CONTROL, OnRedControl)
	ON_COMMAND(ID_FILE_PRINT, OnFilePrint)
	ON_COMMAND(ID_FILE_INFO, OnFileInfo)
	ON_COMMAND(ID_FILE_VX_PRINT, OnFileVxPrint)
	ON_COMMAND(ID_OPT_MEASURE, OnOptMeasure)
	ON_COMMAND(ID_LAYOUT1, OnLayout1)
	ON_COMMAND(ID_LAYOUT2, OnLayout2)
	ON_COMMAND(ID_LAYOUT3, OnLayout3)
	ON_COMMAND(ID_LAYOUT4, OnLayout4)
	ON_COMMAND(ID_LAYOUT5, OnLayout5)
	ON_COMMAND(ID_LAYOUT6, OnLayout6)
	ON_COMMAND(ID_LAYOUT7, OnLayout7)
	ON_COMMAND(ID_LAYOUT8, OnLayout8)
	ON_COMMAND(ID_LAYOUT9, OnLayout9)
	ON_COMMAND(ID_PAGE1, OnPage1)
	ON_COMMAND(ID_PAGE2, OnPage2)
	ON_COMMAND(ID_PAGE3, OnPage3)
	ON_COMMAND(ID_PAGE4, OnPage4)
	ON_COMMAND(ID_PAGE5, OnPage5)
	ON_COMMAND(ID_PAGE6, OnPage6)
	ON_COMMAND(ID_PAGE7, OnPage7)
	ON_COMMAND(ID_PAGE8, OnPage8)
	ON_COMMAND(ID_PAGE9, OnPage9)
	ON_COMMAND(ID_VIEW_RX_SHOW_HELP, OnViewRxShowHelp)
	ON_COMMAND(ID_FILE_SAVE_RASTER, OnFileSaveRaster)
	ON_COMMAND(ID_FILE_SAVE_VECTOR, OnFileSaveVector)
	ON_WM_DESTROY()
	ON_COMMAND(ID_FILE_OVERLAY, OnFileOverlay)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_XPOS,      //Abscise cursor position (in view)
	ID_INDICATOR_YPOS,      //Ordonate cursor position (in view)
   ID_INDICATOR_UNIT,      //Unit type (mm or inches)
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_Action = RX_ACTION_NONE;
}

CMainFrame::~CMainFrame()
{
}
 

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	// create a view to occupy the client area of the frame
	if (!m_wndView.Create(NULL, NULL, WS_CHILD,
		CRect(0, 0, 0, 0), this, IDC_RXVIEWXCTRL, 0))
	{
		TRACE0("Failed to create view window\n");
		return -1;
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	m_wndStatusBar.ShowWindow(SW_SHOW);

	m_wndView.SetShowFileTabs(theApp.m_bShowFileTabs);
	m_wndView.SetShowControlToolbar(theApp.m_bShowControlToolbar);
	m_wndView.SetShowRedlineToolbar(theApp.m_bShowRedlineToolbar);
	m_wndView.SetShowStatusbar(theApp.m_bShowStatusbar);
	m_wndView.SetLayoutOnTabs(theApp.m_bLayoutOnTabs);
	m_wndView.SetShowBirdsEyeView(theApp.m_bShowBirdsEyeView);
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.lpszClass = AfxRegisterWndClass(0);
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers
void CMainFrame::OnSetFocus(CWnd* pOldWnd)
{
	// forward focus to the view window
	m_wndView.SetFocus();
}

BOOL CMainFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	// let the view have first crack at the command
	if (m_wndView.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;

	// otherwise, do default handling
	return CFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}


void CMainFrame::OnSize(UINT nType, int cx, int cy) 
{
	CRect	cr,crs;
	int	h;

	CFrameWnd::OnSize(nType, cx, cy);
	
	GetClientRect(cr);
	h = cr.Height();
	m_wndStatusBar.GetWindowRect(crs);
	h -= crs.Height();
	m_wndView.SetWindowPos(NULL,0,0,cr.Width(),h,SWP_NOOWNERZORDER);
}



void CMainFrame::OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu) 
{
	int		i,k,n;
	long		lFileType;
	double	dFileSize;
	char		fpath[MAX_PATH];
	BSTR		bsname;
	CString	csname;
	CString	csfname;
	UINT		en;

	CFrameWnd::OnInitMenuPopup(pPopupMenu, nIndex, bSysMenu);


	n = m_wndView.GetNumLoadedFiles();
	if (n)
	{
		en = MF_BYCOMMAND | MF_ENABLED;
		bsname = NULL;
		m_wndView.GetFileInfo(&lFileType,&bsname,&dFileSize);
		csfname = bsname;
		SysFreeString(bsname);
		m_wndView.GetLayoutInfo(&m_lNoOfLayouts,&m_lSelLayout,&m_lNoOfPages,&m_lSelPage);
	}
	else
		en = MF_BYCOMMAND | MF_GRAYED;

	if (nIndex == 0)		// file menu
	{
		pPopupMenu->EnableMenuItem(ID_FILE_OPEN, MF_BYCOMMAND | MF_ENABLED);
		pPopupMenu->EnableMenuItem(ID_FILE_CLOSE,en);
		pPopupMenu->EnableMenuItem(ID_FILE_INFO,en);
		pPopupMenu->EnableMenuItem(ID_FILE_SAVE_RASTER,en);
		if (n && lFileType == RX_DOCTYPE_VECTOR_2D)
			pPopupMenu->EnableMenuItem(ID_FILE_SAVE_VECTOR,en);
		else
			pPopupMenu->EnableMenuItem(ID_FILE_SAVE_VECTOR,MF_BYCOMMAND | MF_GRAYED);
		if (n >= 2)
			pPopupMenu->EnableMenuItem(ID_FILE_OVERLAY,en);
		else
			pPopupMenu->EnableMenuItem(ID_FILE_OVERLAY,MF_BYCOMMAND | MF_GRAYED);
		pPopupMenu->EnableMenuItem(ID_FILE_PRINT,en);
		pPopupMenu->EnableMenuItem(ID_FILE_VX_PRINT,en);

		for (i=0; i<8; i++)
			pPopupMenu->DeleteMenu(ID_FILE1+i,MF_BYCOMMAND);
		k = m_wndView.GetNumRecentFiles();
		for (i=0; i<8; i++)
		{
			if (i < k)
			{
				bsname = NULL;
				if (m_wndView.GetRecentFileName(i,&bsname))
				{
					csname = bsname;
					wsprintf(fpath,"&%d ",i+1);
					strcat(fpath,csname);
					pPopupMenu->AppendMenu(MF_BYCOMMAND,ID_FILE1+i,fpath);
				}
				SysFreeString(bsname);
			}
		}
	}

	if (nIndex == 1)		// view menu
	{
		pPopupMenu->EnableMenuItem(ID_VIEW_RX_STATUS_BAR, MF_BYCOMMAND | MF_ENABLED);
		if (m_wndView.GetShowStatusbar())
			pPopupMenu->CheckMenuItem(ID_VIEW_RX_STATUS_BAR, MF_BYCOMMAND | MF_CHECKED);
		else
			pPopupMenu->CheckMenuItem(ID_VIEW_RX_STATUS_BAR, MF_BYCOMMAND | MF_UNCHECKED);

		pPopupMenu->EnableMenuItem(ID_VIEW_RX_CONTROL_BAR, MF_BYCOMMAND | MF_ENABLED);
		if (m_wndView.GetShowControlToolbar())
			pPopupMenu->CheckMenuItem(ID_VIEW_RX_CONTROL_BAR, MF_BYCOMMAND | MF_CHECKED);
		else
			pPopupMenu->CheckMenuItem(ID_VIEW_RX_CONTROL_BAR, MF_BYCOMMAND | MF_UNCHECKED);

		pPopupMenu->EnableMenuItem(ID_VIEW_RX_REDLINE_BAR, MF_BYCOMMAND | MF_ENABLED);
		if (m_wndView.GetShowRedlineToolbar())
			pPopupMenu->CheckMenuItem(ID_VIEW_RX_REDLINE_BAR, MF_BYCOMMAND | MF_CHECKED);
		else
			pPopupMenu->CheckMenuItem(ID_VIEW_RX_REDLINE_BAR, MF_BYCOMMAND | MF_UNCHECKED);

		pPopupMenu->EnableMenuItem(ID_VIEW_RX_FILE_TABS, MF_BYCOMMAND | MF_ENABLED);
		if (m_wndView.GetShowFileTabs())
			pPopupMenu->CheckMenuItem(ID_VIEW_RX_FILE_TABS, MF_BYCOMMAND | MF_CHECKED);
		else
			pPopupMenu->CheckMenuItem(ID_VIEW_RX_FILE_TABS, MF_BYCOMMAND | MF_UNCHECKED);

		pPopupMenu->EnableMenuItem(ID_VIEW_RX_LAY_ON_TABS, MF_BYCOMMAND | MF_ENABLED);
		if (m_wndView.GetLayoutOnTabs())
			pPopupMenu->CheckMenuItem(ID_VIEW_RX_LAY_ON_TABS, MF_BYCOMMAND | MF_CHECKED);
		else
			pPopupMenu->CheckMenuItem(ID_VIEW_RX_LAY_ON_TABS, MF_BYCOMMAND | MF_UNCHECKED);

		pPopupMenu->EnableMenuItem(ID_VIEW_BEV,en);
		if (m_wndView.GetShowBirdsEyeView())
			pPopupMenu->CheckMenuItem(ID_VIEW_BEV, MF_BYCOMMAND | MF_CHECKED);
		else
			pPopupMenu->CheckMenuItem(ID_VIEW_BEV, MF_BYCOMMAND | MF_UNCHECKED);
		
		pPopupMenu->EnableMenuItem(ID_VIEW_RX_SHOW_HELP, MF_BYCOMMAND | MF_ENABLED);
		if (m_wndView.GetShowHelpButtons())
			pPopupMenu->CheckMenuItem(ID_VIEW_RX_SHOW_HELP, MF_BYCOMMAND | MF_CHECKED);
		else
			pPopupMenu->CheckMenuItem(ID_VIEW_RX_SHOW_HELP, MF_BYCOMMAND | MF_UNCHECKED);

//		pPopupMenu->EnableMenuItem(ID_VIEW_BEV,en);
	}

	if (nIndex == 2)		// layout menu
	{
		for (i=0; i<9; i++)
			pPopupMenu->DeleteMenu(ID_LAYOUT1+i,MF_BYCOMMAND);
		if (n)
		{
			if (m_lNoOfLayouts > 9) m_lNoOfLayouts = 9;
			for (i=0; i<m_lNoOfLayouts; i++)
			{
				bsname = NULL;
				if (m_wndView.GetLayoutName(i,&bsname))
				{
					csname = bsname;
					strcpy(fpath,csname);
					pPopupMenu->AppendMenu(MF_BYCOMMAND,ID_LAYOUT1+i,fpath);
					if (i == m_lSelLayout)
						pPopupMenu->CheckMenuItem(ID_LAYOUT1+i, MF_BYCOMMAND | MF_CHECKED);
				}
				SysFreeString(bsname);
			}
		}
	}

	if (nIndex == 3)		// page menu
	{
		for (i=0; i<9; i++)
			pPopupMenu->DeleteMenu(ID_PAGE1+i,MF_BYCOMMAND);
		if (n)
		{
			if (m_lNoOfPages == -1 || m_lNoOfPages > 9)
			{
				pPopupMenu->AppendMenu(MF_BYCOMMAND,ID_PAGE1,"&First Page");
				pPopupMenu->AppendMenu(MF_BYCOMMAND,ID_PAGE2,"&Next Page");
				pPopupMenu->AppendMenu(MF_BYCOMMAND,ID_PAGE3,"&Previous Page");
				pPopupMenu->AppendMenu(MF_BYCOMMAND,ID_PAGE4,"&Last Page");
				if (m_lSelPage == 0)
					pPopupMenu->EnableMenuItem(ID_PAGE1, MF_BYCOMMAND | MF_GRAYED);
				if (m_lNoOfPages != -1 && m_lSelPage >= m_lNoOfPages-1)
					pPopupMenu->EnableMenuItem(ID_PAGE2, MF_BYCOMMAND | MF_GRAYED);
				if (m_lSelPage == 0)
					pPopupMenu->EnableMenuItem(ID_PAGE3, MF_BYCOMMAND | MF_GRAYED);
				if (m_lNoOfPages == -1)
					pPopupMenu->EnableMenuItem(ID_PAGE4, MF_BYCOMMAND | MF_GRAYED);
			}
			else
			{
				for (i=0; i<m_lNoOfPages; i++)
				{
					bsname = NULL;
					if (m_wndView.GetPageName(i,&bsname))
					{
						csname = bsname;
						strcpy(fpath,csname);
						pPopupMenu->AppendMenu(MF_BYCOMMAND,ID_PAGE1+i,fpath);
						if (i == m_lSelPage)
							pPopupMenu->CheckMenuItem(ID_PAGE1+i, MF_BYCOMMAND | MF_CHECKED);
					}
					SysFreeString(bsname);
				}
			}
		}
	}

	if (nIndex == 4)		// zoom menu
	{
		pPopupMenu->EnableMenuItem(ID_ZOOM_WINDOW,en);
		if (m_Action == RX_ACTION_ZOOM)
			pPopupMenu->CheckMenuItem(ID_ZOOM_WINDOW, MF_BYCOMMAND | MF_CHECKED);
		else
			pPopupMenu->CheckMenuItem(ID_ZOOM_WINDOW, MF_BYCOMMAND | MF_UNCHECKED);
		pPopupMenu->EnableMenuItem(ID_ZOOM_NONE,en);
		pPopupMenu->EnableMenuItem(ID_ZOOM_ALL,en);
		pPopupMenu->EnableMenuItem(ID_ZOOM_WIDTH,en);
		pPopupMenu->EnableMenuItem(ID_ZOOM_HEIGHT,en);
		pPopupMenu->EnableMenuItem(ID_ZOOM_IN,en);
		pPopupMenu->EnableMenuItem(ID_ZOOM_OUT,en);
		pPopupMenu->EnableMenuItem(ID_PAN,en);
		if (m_Action == RX_ACTION_PAN)
			pPopupMenu->CheckMenuItem(ID_PAN, MF_BYCOMMAND | MF_CHECKED);
		else
			pPopupMenu->CheckMenuItem(ID_PAN, MF_BYCOMMAND | MF_UNCHECKED);
	}

	if (nIndex == 5)		// Redline menu
	{
		if (!m_wndView.GetHaveRedlineModule())
		{
			pPopupMenu->EnableMenuItem(ID_RED_PREF, MF_BYCOMMAND | MF_GRAYED);
			pPopupMenu->EnableMenuItem(ID_RED_CONTROL, MF_BYCOMMAND | MF_GRAYED);
		}
		else
		{
			pPopupMenu->EnableMenuItem(ID_RED_PREF, MF_BYCOMMAND | MF_ENABLED);
			pPopupMenu->EnableMenuItem(ID_RED_CONTROL,en);
		}
	}

	if (nIndex == 6)		// Options menu
	{
		pPopupMenu->EnableMenuItem(ID_OPT_FILTER, MF_BYCOMMAND | MF_ENABLED);
		pPopupMenu->EnableMenuItem(ID_OPT_PREF, MF_BYCOMMAND | MF_ENABLED);
		if (n)
		{
			if (lFileType == RX_DOCTYPE_VECTOR_2D || lFileType == RX_DOCTYPE_VECTOR_3D)
				pPopupMenu->EnableMenuItem(ID_OPT_VECTOR, MF_BYCOMMAND | MF_ENABLED);
			else
				pPopupMenu->EnableMenuItem(ID_OPT_VECTOR, MF_BYCOMMAND | MF_GRAYED);
		}
		else
			pPopupMenu->EnableMenuItem(ID_OPT_VECTOR, MF_BYCOMMAND | MF_GRAYED);
		pPopupMenu->EnableMenuItem(ID_OPT_MEASURE,en);
		if (m_Action == RX_ACTION_MEASURE)
			pPopupMenu->CheckMenuItem(ID_OPT_MEASURE, MF_BYCOMMAND | MF_CHECKED);
		else
			pPopupMenu->CheckMenuItem(ID_OPT_MEASURE, MF_BYCOMMAND | MF_UNCHECKED);
	}
	
	if (nIndex == 7)		// Window menu
	{
		pPopupMenu->EnableMenuItem(ID_WINDOW_CLOSE,en);
		pPopupMenu->EnableMenuItem(ID_WINDOW_CLOSE_ALL,en);
		for (i=0; i<9; i++)
			pPopupMenu->DeleteMenu(ID_WINDOW1+i,MF_BYCOMMAND);
		for (i=0; i<9; i++)
		{
			if (i < n)
			{
				bsname = NULL;
				if (m_wndView.GetLoadedFileName(i,&bsname))
				{
					csname = bsname;
					strcpy(fpath,csname);
					pPopupMenu->AppendMenu(MF_BYCOMMAND,ID_WINDOW1+i,fpath);
				}
				SysFreeString(bsname);
			}
		}
	}
}


void CMainFrame::OnViewRxFileTabs() 
{
	theApp.m_bShowFileTabs = !theApp.m_bShowFileTabs;
	m_wndView.SetShowFileTabs(theApp.m_bShowFileTabs);
}

void CMainFrame::OnViewRxControlBar() 
{
	theApp.m_bShowControlToolbar = !theApp.m_bShowControlToolbar;
	m_wndView.SetShowControlToolbar(theApp.m_bShowControlToolbar);
}

void CMainFrame::OnViewRxRedlineBar() 
{
	theApp.m_bShowRedlineToolbar = !theApp.m_bShowRedlineToolbar;
	m_wndView.SetShowRedlineToolbar(theApp.m_bShowRedlineToolbar);
}

void CMainFrame::OnViewRxStatusBar() 
{
	theApp.m_bShowStatusbar = !theApp.m_bShowStatusbar;
	m_wndView.SetShowStatusbar(theApp.m_bShowStatusbar);
}

void CMainFrame::OnViewRxLayOnTabs() 
{
	theApp.m_bLayoutOnTabs = !theApp.m_bLayoutOnTabs;
	m_wndView.SetLayoutOnTabs(theApp.m_bLayoutOnTabs);
}
void CMainFrame::OnViewBev() 
{
	theApp.m_bShowBirdsEyeView = !theApp.m_bShowBirdsEyeView;
	m_wndView.SetShowBirdsEyeView(theApp.m_bShowBirdsEyeView);
}

void CMainFrame::OnViewRxShowHelp() 
{
	m_wndView.SetShowHelpButtons(!m_wndView.GetShowHelpButtons());
}

void CMainFrame::OnZoomWindow() 
{
	if (m_Action == RX_ACTION_ZOOM)
		m_Action = RX_ACTION_NONE;
	else 
		m_Action = RX_ACTION_ZOOM;
	m_wndView.SetMouseActionType(m_Action,0,0);
}
void CMainFrame::OnZoomNone() 
{
	m_wndView.Zoom(RX_ZOOM_NONE);
}

void CMainFrame::OnZoomAll() 
{
	m_wndView.Zoom(RX_ZOOM_EXTENT);
	
}

void CMainFrame::OnZoomHeight() 
{
	m_wndView.Zoom(RX_ZOOM_HEIGHT);
}

void CMainFrame::OnZoomWidth() 
{
	m_wndView.Zoom(RX_ZOOM_WIDTH);
}


void CMainFrame::OnZoomIn() 
{
	m_wndView.Zoom(RX_ZOOM_IN);
}

void CMainFrame::OnZoomOut() 
{
	m_wndView.Zoom(RX_ZOOM_OUT);
}


void CMainFrame::OnPan() 
{
	if (m_Action == RX_ACTION_PAN)
		m_Action = RX_ACTION_NONE;
	else 
		m_Action = RX_ACTION_PAN;
	m_wndView.SetMouseActionType(m_Action,0,0);
}

void CMainFrame::OnFileOpen() 
{
	m_wndView.FileOpenDialog();
}

void CMainFrame::OnFileClose() 
{
	m_wndView.CloseFile(FALSE,"");
}
void CMainFrame::OnFileSaveRaster() 
{
	m_wndView.SaveToRasterDialog();
}
void CMainFrame::OnFileSaveVector() 
{
	m_wndView.SaveToVectorDialog();
}
void CMainFrame::OnFileOverlay() 
{
	m_wndView.OverlayDialog();
}
void CMainFrame::OnFileInfo() 
{
	m_wndView.FileInfoDialog();
}
void CMainFrame::OnFilePrint() 
{
	m_wndView.PrintDocument();
}
void CMainFrame::OnFileVxPrint() 
{
	m_wndView.PrintDocument();
}

void CMainFrame::OnWindowClose() 
{
	m_wndView.CloseFile(FALSE,"");
}

void CMainFrame::OnWindowCloseAll() 
{
	m_wndView.CloseFile(TRUE,"");
}


void CMainFrame::DoOnFile(int index) 
{
	BSTR		bsname;
	CString	csname;
	char		name[MAX_PATH];

	bsname = NULL;
	if (m_wndView.GetRecentFileName(index,&bsname))
	{
		csname = bsname;
		strcpy(name,csname);
		m_wndView.FileOpen(name,"");
	}
	SysFreeString(bsname);
}

void CMainFrame::OnFile1() 
{
	DoOnFile(0); 
}
void CMainFrame::OnFile2() 
{
	DoOnFile(1); 
}
void CMainFrame::OnFile3() 
{
	DoOnFile(2); 
}
void CMainFrame::OnFile4() 
{
	DoOnFile(3); 
}
void CMainFrame::OnFile5() 
{
	DoOnFile(4); 
}
void CMainFrame::OnFile6() 
{
	DoOnFile(5); 
}
void CMainFrame::OnFile7() 
{
	DoOnFile(6); 
}
void CMainFrame::OnFile8() 
{
	DoOnFile(7); 
}

void CMainFrame::DoOnWindow(int index) 
{
	BSTR		bsname;
	CString	csname;
	char		name[MAX_PATH];

	bsname = NULL;
	if (m_wndView.GetLoadedFileName(index,&bsname))
	{
		csname = bsname;
		strcpy(name,csname);
		m_wndView.ActivateFile(name);
	}
	SysFreeString(bsname);
}
void CMainFrame::OnWindow1() 
{
	DoOnWindow(0); 
}
void CMainFrame::OnWindow2() 
{
	DoOnWindow(1); 
}
void CMainFrame::OnWindow3() 
{
	DoOnWindow(2); 
}
void CMainFrame::OnWindow4() 
{
	DoOnWindow(3); 
}
void CMainFrame::OnWindow5() 
{
	DoOnWindow(4); 
}
void CMainFrame::OnWindow6() 
{
	DoOnWindow(5); 
}
void CMainFrame::OnWindow7() 
{
	DoOnWindow(6); 
}
void CMainFrame::OnWindow8() 
{
	DoOnWindow(7); 
}
void CMainFrame::OnWindow9() 
{
	DoOnWindow(8); 
}


void CMainFrame::OnOptFilter() 
{
	m_wndView.FilterInfoDialog();
}

void CMainFrame::OnOptPref() 
{
	m_wndView.PreferenceDialog();
}

void CMainFrame::OnOptVector() 
{
	m_wndView.FileVectorControlDialog();
}

void CMainFrame::OnRedPref() 
{
	m_wndView.RedlinePreferenceDialog();
}

void CMainFrame::OnRedControl() 
{
	m_wndView.RedlineControlDialog();
}

void CMainFrame::OnOptMeasure() 
{
	if (m_Action == RX_ACTION_MEASURE)
		m_Action = RX_ACTION_NONE;
	else 
		m_Action = RX_ACTION_MEASURE;
	m_wndView.SetMouseActionType(m_Action,0,0);
}


void CMainFrame::OnLayout1() 
{
	m_wndView.SelectLayout(0);
}
void CMainFrame::OnLayout2() 
{
	m_wndView.SelectLayout(1);
}
void CMainFrame::OnLayout3() 
{
	m_wndView.SelectLayout(2);
}
void CMainFrame::OnLayout4() 
{
	m_wndView.SelectLayout(3);
}
void CMainFrame::OnLayout5() 
{
	m_wndView.SelectLayout(4);
}
void CMainFrame::OnLayout6() 
{
	m_wndView.SelectLayout(5);
}
void CMainFrame::OnLayout7() 
{
	m_wndView.SelectLayout(6);
}
void CMainFrame::OnLayout8() 
{
	m_wndView.SelectLayout(7);
}
void CMainFrame::OnLayout9() 
{
	m_wndView.SelectLayout(8);
}

void CMainFrame::OnPage1() 
{
	m_wndView.SelectPage(0);
}
void CMainFrame::OnPage2() 
{
	if (m_lNoOfPages == -1 || m_lNoOfPages > 9)
		m_wndView.SelectPage(m_lSelPage+1);
	else
		m_wndView.SelectPage(1);
}
void CMainFrame::OnPage3() 
{
	if (m_lNoOfPages == -1 || m_lNoOfPages > 9)
		m_wndView.SelectPage(m_lSelPage-1);
	else
		m_wndView.SelectPage(2);
}
void CMainFrame::OnPage4() 
{
	if (m_lNoOfPages == -1 || m_lNoOfPages > 9)
		m_wndView.SelectPage(m_lNoOfPages-1);
	else
		m_wndView.SelectPage(3);
}
void CMainFrame::OnPage5() 
{
	m_wndView.SelectPage(4);
}
void CMainFrame::OnPage6() 
{
	m_wndView.SelectPage(5);
}
void CMainFrame::OnPage7() 
{
	m_wndView.SelectPage(6);
}
void CMainFrame::OnPage8() 
{
	m_wndView.SelectPage(7);
}
void CMainFrame::OnPage9() 
{
	m_wndView.SelectPage(8);
}

BEGIN_EVENTSINK_MAP(CMainFrame, CFrameWnd)
    //{{AFX_EVENTSINK_MAP(CMainFrame)
	ON_EVENT(CMainFrame, IDC_RXVIEWXCTRL, -605 /* MouseDown */, OnMouseDownRxviewxctrl, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CMainFrame, IDC_RXVIEWXCTRL, -607 /* MouseUp */, OnMouseUpRxviewxctrl, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CMainFrame, IDC_RXVIEWXCTRL, -606 /* MouseMove */, OnMouseMoveRxviewxctrl, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CMainFrame, IDC_RXVIEWXCTRL, 5 /* HelpWanted */, OnHelpWantedRxviewxctrl, VTS_I2)
	ON_EVENT(CMainFrame, IDC_RXVIEWXCTRL, 6 /* StatusInformation */, OnStatusInformationRxviewxctrl, VTS_BSTR)
	ON_EVENT(CMainFrame, IDC_RXVIEWXCTRL, 7 /* FileOpen */, OnFileOpenRxviewxctrl, VTS_PBSTR VTS_PI4)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CMainFrame::OnMouseDownRxviewxctrl(short Button, short Shift, long x, long y) 
{
	int i;

	i = 0;
}

void CMainFrame::OnMouseUpRxviewxctrl(short Button, short Shift, long x, long y) 
{
	int i;

	i = 0;
}

void CMainFrame::OnMouseMoveRxviewxctrl(short Button, short Shift, long x, long y) 
{
	double	dx,dy;
	long		lx,ly;
	short		nPres;
	char		sTxt2[30];
	char		sTxt1[30];
	BSTR		bsUnit;
	CString	csUnit;
	char		sUnit[30];


	// Display original coordinates and units in status bar
	lx = x;
	ly = y;
	if (!m_wndView.Screen2World(&lx,&ly))	// Convert to RimEngine units
		return;
	dx = lx;
	dy = ly;
	bsUnit = NULL;
	if (!m_wndView.World2Original(&dx,&dy,&nPres,&bsUnit))
		return;
	csUnit = bsUnit;
	strcpy(sUnit,csUnit);

	Double2Str(sTxt1,dx,nPres);
	strcpy(sTxt2,"x=");
	strcat(sTxt2,sTxt1);
	m_wndStatusBar.SetPaneText(1,(LPCTSTR)sTxt2,TRUE);
	Double2Str(sTxt1,dy,nPres);
	strcpy(sTxt2,"y=");
	strcat(sTxt2,sTxt1);
	m_wndStatusBar.SetPaneText(2,(LPCTSTR)sTxt2,TRUE);
	m_wndStatusBar.SetPaneText(3,(LPCTSTR)sUnit,TRUE);
}

void CMainFrame::OnHelpWantedRxviewxctrl(short nDialogID) 
{
	char	txt[30];

	wsprintf(txt,"Dialog ID %d",nDialogID);
	::MessageBox(NULL, txt, "Dialog Help Wanted", MB_OK | MB_ICONHAND);
	
}
	
void CMainFrame::OnStatusInformationRxviewxctrl(LPCTSTR sStatusText) 
{
	m_wndStatusBar.SetPaneText(0,sStatusText, TRUE);
}

void CMainFrame::OnFileOpenRxviewxctrl(BSTR FAR* psFileName, long FAR* bOK) 
{
	// This event allows the client to control file opening
	// to prevent the file from being opened
	// *bOK = FALSE;
	// To change the name of the file to be opened:
	// *psFileName = CComBSTR("C:\\newfilename");
}

/***********************************************************************
* Split a path/filename to file name
************************************************************************/
void CMainFrame::SplitFileName(LPSTR PathName, LPSTR FileName)
{
	char		SplitPath[MAX_PATH];
	char		SplitExt[MAX_PATH];
	char		SplitDrive[4];
	
	_splitpath(PathName,SplitDrive,SplitPath,FileName,SplitExt);
}
/***********************************************************************
* Convert double to text string
************************************************************************/
void CMainFrame::Double2Str(char * str, double ant, int pres)
{
	char		*tx;
	int		i,k,pp,sp;
	
	tx = _fcvt((double)ant,pres,&pp,&sp);
	i = 0;
	if (sp)
		str[i++] = '-';
	if (pp < 1)
	{
		str[i++] = '0';
		if (pres == 0)
			str[i++] = 0;
		else
		{
			str[i++] = '.';
			pp++;
			while (pp++ < 1)
				str[i++] = '0';
			str[i++] = 0;
			lstrcat(str,tx);
		}
	}
	else
	{
		k = 0;
		while (pp--)
			str[i++] = tx[k++];
		str[i] = 0;
		if (pres > 0)
		{
			str[i++] = '.';
			str[i++] = 0;
			lstrcat(str,&tx[k]);
		}
	}
}





void CMainFrame::OnDestroy() 
{
	WINDOWPLACEMENT wp;

	CFrameWnd::OnDestroy();
	
	wp.length = sizeof(WINDOWPLACEMENT);
	GetWindowPlacement(&wp);
	if (wp.showCmd == SW_SHOWMAXIMIZED)
		theApp.m_bMaximized = TRUE;
	else
		theApp.m_bMaximized = FALSE;
	theApp.m_lFrameL = wp.rcNormalPosition.left;
	theApp.m_lFrameT = wp.rcNormalPosition.top;
	theApp.m_lFrameW = wp.rcNormalPosition.right-wp.rcNormalPosition.left;
	theApp.m_lFrameH = wp.rcNormalPosition.bottom-wp.rcNormalPosition.top;
}

