/********************************************************************************
*****
*****
*****		PROGRAM			: RxViewX_Samles_MFC
*****
*****		MODULE			: RxViewXDefinitions.h
*****
*****		PURPOSE			: General RxViewX definitions
*****
********************************************************************************/


enum RX_DOCUMENT_TYPE
{
    RX_DOCTYPE_TEXT = 0,
    RX_DOCTYPE_HTML = 1,
    RX_DOCTYPE_RASTER = 2,
    RX_DOCTYPE_VECTOR_2D = 3,
    RX_DOCTYPE_VECTOR_3D = 4,
    RX_DOCTYPE_WORKSPACE = 5,
    RX_DOCTYPE_SPREADSHEET = 6
};


#define  MPERI	(double)25.4   		//mm per inch
enum {M_SYSTEM = 0, M_IMPERIAL, M_METRIC, M_USER};


// Defines pen table styles
#define  PS_DEFAULT			-1  //Default
#define  PS_SOLID				0   //Solid Pen
#define  PS_DASH				1   //Dash Pen
#define  PS_DOT				2   //Dot Pen
#define  PS_DASHDOT			3   //DashDot Pen
#define  PS_DASHDOTDOT		4	 //DashDotDot Pen


// Defines Zoom types
typedef enum
{
	RX_ZOOM_NONE,					// UnZoomed 1:1
	RX_ZOOM_EXTENT,				// Zoom all
	RX_ZOOM_WIDTH,					// Zoom width
	RX_ZOOM_HEIGHT,				// Zoom height
	RX_ZOOM_IN,						// Zoom in
	RX_ZOOM_OUT,					// Zoom out
} RX_ZOOM;

// Defines the RxViewX mouse draw actions
typedef enum
{
	RX_ACTION_NONE,				// No action to be performed
	RX_ACTION_ZOOM,				// Zoom window
	RX_ACTION_PAN, 				// Pan
	RX_ACTION_CALIBRATE,			// Calibrate drawing
	RX_ACTION_MEASURE,			// Measure drawing
	RX_ACTION_RED_EDIT,			// Redline action Edit
	RX_ACTION_RED_PUSH,			// Redline action Push link and note buttons
	RX_ACTION_RED_RUBB,			// Redline action Rubbout
	RX_ACTION_RED_LINK,			// Redline action Make link button
	RX_ACTION_RED_TEXT,			// Redline action Draw text or note
	RX_ACTION_RED_LINE,			// Redline action Draw lines
	RX_ACTION_RED_ARROW,			// Redline action Draw arrow
	RX_ACTION_RED_RECT,			// Redline action Draw rectangles/ovals etc
} RX_ACTION;

// define Rubber Element SUBTYPES
#define RED_RUBB_PEN   		0				// Rubber pen
#define RED_RUBB_BAND		1				// Rubber band

// define Line Element SUBTYPES
#define RED_LINE_PEN			0				// Freehand pen
#define RED_LINE_LINE		1				// Polylines
#define RED_LINE_CURVE		2				// Polycurves
#define RED_LINE_AREA		3				// Measurement area

// define Rect Element SUBTYPES
#define RED_RECT_RECT		0				// Rectangle
#define RED_RECT_ROUND		1				// RoundedRectangle
#define RED_RECT_OVAL		2				// Oval
#define RED_RECT_BUBBLE		3				// Bubble

// define Arrow Element SUBTYPES
#define RED_ARROW_ARROW		0				// Normal Arrow
#define RED_ARROW_DIM		1				// Dimention line

// define Text Element SUBTYPES
#define RED_TEXT_NORMAL		0				// Normal text
#define RED_TEXT_ARROW 		1				// Arrow Pointed text
#define RED_TEXT_NOTE 		2				// Note wrapped text

// define Picture Element SUBTYPES
#define RED_PICT_META		0				// metafile picture
#define RED_PICT_DIB			1				// Dib bitmap picture

// defines alternate RED_TEXT and RED_ATEXT types
#define RED_TXTTRANSP  	0     // Unframed text
#define RED_TXTRECT    	1     // Enclosed in outlined rectangle
#define RED_TXTRRECT   	2     // Enclosed in outlined rounded corner rectangle
#define RED_TXTBUBBLE	3     // Enclosed in outlined talk bubble
#define RED_TXTERECT   	4     // Enclosed in edged rectangle
#define RED_TXTERRECT   5     // Enclosed in edged rounded corner rectangle
#define RED_TXTEBUBBLE	6     // Enclosed in edged talk bubble

// defines alternate RED_LINE, RED_SPLINE, RED_RECT, RED_RRECT, RED_OVAL and RED_BUBBLE types
#define RED_OPEN  		0		//	Open/Outlined
#define RED_CLOSED		1		//	Closed/Outlined
#define RED_FILLED 		2		//	Closed and filled
#define RED_EDGED  		3		//	Outlined width redline color and filled with background color

// defines alternate RED_ARROW types
#define RED_OSINGLE		0     // Single headed outlined arrow
#define RED_FSINGLE	 	1     // Single headed filled arrow
#define RED_ODOUBLE    	2     // Double headed outlined arrow
#define RED_FDOUBLE   	3     // Double headed filled arrow

// defines alternate RED_MEAS types
#define RED_MEASURE 		0    // Lines 90 degree on measurement line
#define RED_CIRCLES 		1    // Filled circles 
#define RED_ODWITHL    	2    // Double headed outlined arrow pluss 90 degree lines
#define RED_FDWITHL   	3    // Double headed filled arrow pluss 90 degree lines
