// RxViewX_Sample_MFC.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "RxViewX_Sample_MFC.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static const char pszRegKey[] = _T("Rasterex");
CMainFrame* pMain;

/////////////////////////////////////////////////////////////////////////////
// CRxViewX_Sample_MFCApp

BEGIN_MESSAGE_MAP(CRxViewX_Sample_MFCApp, CWinApp)
	//{{AFX_MSG_MAP(CRxViewX_Sample_MFCApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRxViewX_Sample_MFCApp construction

CRxViewX_Sample_MFCApp::CRxViewX_Sample_MFCApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CRxViewX_Sample_MFCApp object

CRxViewX_Sample_MFCApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CRxViewX_Sample_MFCApp initialization

BOOL CRxViewX_Sample_MFCApp::InitInstance()
{

	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(pszRegKey);

	m_lFrameL = 100;
	m_lFrameT = 100;
	m_lFrameW = 600;
	m_lFrameH = 500;
	m_bMaximized = FALSE;
	m_bShowFileTabs = TRUE;
	m_bShowControlToolbar = TRUE;
	m_bShowRedlineToolbar = TRUE;
	m_bShowStatusbar = FALSE;
	m_bLayoutOnTabs = FALSE;
	m_bShowBirdsEyeView = FALSE;

	LoadSaveRegSettings(FALSE);

	// To create the main window, this code creates a new frame window
	// object and then sets it as the application's main window object.

	CMainFrame* pFrame = new CMainFrame;
	m_pMainWnd = pFrame;
	pMain = pFrame;

	// create and load the frame with its resources

	pFrame->LoadFrame(IDR_MAINFRAME,	WS_OVERLAPPEDWINDOW | FWS_ADDTOTITLE, NULL, NULL);
	pFrame->SetWindowPos(NULL,m_lFrameL,m_lFrameT,m_lFrameW,m_lFrameH,SWP_NOOWNERZORDER);

	// The one and only window has been initialized, so show and update it.
	if (m_bMaximized)
		pFrame->ShowWindow(SW_SHOWMAXIMIZED);
	else
		pFrame->ShowWindow(SW_SHOW);
	pFrame->UpdateWindow();

	return TRUE;
}

int CRxViewX_Sample_MFCApp::ExitInstance() 
{
	LoadSaveRegSettings(TRUE);

	return CWinApp::ExitInstance();
}

/////////////////////////////////////////////////////////////////////////////
// CRxViewX_Sample_MFCApp message handlers

void CRxViewX_Sample_MFCApp::LoadSaveLong(BOOL save, LPSTR sSection, LPSTR sEntry, long *value)
{
	if (save)
		AfxGetApp()->WriteProfileInt(sSection,sEntry,(int)*value);
	else
		*value = AfxGetApp()->GetProfileInt(sSection,sEntry,(int)*value);
}


void CRxViewX_Sample_MFCApp::LoadSaveString(BOOL save, LPSTR sSection, LPSTR sEntry, CString *value)
{
	char	str[MAX_PATH*2];

	strcpy(str,*value);
	if (save)
		AfxGetApp()->WriteProfileString(sSection,sEntry,*value);
	else
		*value = AfxGetApp()->GetProfileString(sSection,sEntry,str);
}


void CRxViewX_Sample_MFCApp::LoadSaveRegSettings(BOOL save)
{

	LoadSaveLong(save,"Preferences","FrameLeft", &m_lFrameL);
	LoadSaveLong(save,"Preferences","FrameTop", &m_lFrameT);
	LoadSaveLong(save,"Preferences","FrameWith", &m_lFrameW);
	LoadSaveLong(save,"Preferences","Frameheight", &m_lFrameH);
	LoadSaveLong(save,"Preferences","Maximized", (long*)&m_bMaximized);
	LoadSaveLong(save,"Preferences","ShowFileTabs", (long*)&m_bShowFileTabs);
	LoadSaveLong(save,"Preferences","ShowControlToolbar", (long*)&m_bShowControlToolbar);
	LoadSaveLong(save,"Preferences","ShowRedlineToolbar", (long*)&m_bShowRedlineToolbar);
	LoadSaveLong(save,"Preferences","ShowStatusbar", (long*)&m_bShowStatusbar);
	LoadSaveLong(save,"Preferences","LayoutOnTabs", (long*)&m_bLayoutOnTabs);
	LoadSaveLong(save,"Preferences","ShowBirdsEyeView", (long*)&m_bShowBirdsEyeView);
}



/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CString	m_sCopyRight;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	afx_msg void OnBhomepage();
	virtual BOOL OnInitDialog();
	afx_msg void OnAbout();
	virtual void OnOK();
	virtual void OnCancel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	m_sCopyRight = _T("");
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Text(pDX, IDC_COPYRIGHTSTRING, m_sCopyRight);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_BN_CLICKED(IDC_BHOMEPAGE, OnBhomepage)
	ON_BN_CLICKED(IDC_ABOUT, OnAbout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CRxViewX_Sample_MFCApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CRxViewX_Sample_MFCApp message handlers



void CAboutDlg::OnBhomepage() 
{
	//Go to Rasterex Internet Home Page
   ::ShellExecute(this->GetSafeHwnd(), _T("open"), _T("http://www.rasterex.com"), NULL, NULL, SW_SHOWNORMAL);
}

BOOL CAboutDlg::OnInitDialog() 
{
	CString s;

	CDialog::OnInitDialog();

	m_sCopyRight = _T("Copyright (c) 1993-2002. Rasterex (International) a.s.");

	UpdateData(FALSE);

		
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAboutDlg::OnAbout() 
{
	pMain->m_wndView.AboutBox();
}

void CAboutDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}

void CAboutDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}



